VERSION 5.00
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Test"
   ClientHeight    =   6000
   ClientLeft      =   3270
   ClientTop       =   1995
   ClientWidth     =   6750
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6000
   ScaleWidth      =   6750
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   4800
      TabIndex        =   2
      Top             =   5340
      Width           =   1875
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   2430
      TabIndex        =   1
      Top             =   5340
      Width           =   1875
   End
   Begin VB.CommandButton cmdTryIt 
      Caption         =   "Try It"
      Height          =   495
      Left            =   60
      TabIndex        =   0
      Top             =   5340
      Width           =   1875
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Declare an object variable for the FSO (mobjFSO) at the form (module) level.
' This way it is available to all Subs and Functions in the form. The "New"
' keyword is used, making the various methods and properties of the FSO
' available without using a separate "Set" statement to instantiate it.

Private mobjFSO  As New FileSystemObject

'------------------------------------------------------------------------------------------
Private Sub cmdTryIt_Click()
'------------------------------------------------------------------------------------------

    On Error GoTo cmdTryIt_Click_Error
    
    Cls
    
    ' Make the top-level subdirectories below the root with
    ' the CreateFolder method of the FSO ...
    mobjFSO.CreateFolder "A:\SYSTEM"
    mobjFSO.CreateFolder "A:\COMMAND"
    mobjFSO.CreateFolder "A:\EXECUTE"
    mobjFSO.CreateFolder "A:\INITIAL"
    mobjFSO.CreateFolder "A:\TEXT"
    mobjFSO.CreateFolder "A:\WRITE"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Top-level directories have been made."
    Refresh
    
    ' To faciliate the moving of the files to their proper directories, a Sub named
    ' CopyOrMoveFiles was written. The Sub takes four arguments: (1) source path,
    ' (2) target path, (3) file extension, and (4) a one-character code indicating
    ' whether the files should be moved ("M") or copied ("C"). The Sub is called six
    ' times, once for each file type to be moved from the root to its proper directory.
    CopyOrMoveFiles "A:\", "A:\SYSTEM", "SYS", "M"
    CopyOrMoveFiles "A:\", "A:\COMMAND", "COM", "M"
    CopyOrMoveFiles "A:\", "A:\EXECUTE", "EXE", "M"
    CopyOrMoveFiles "A:\", "A:\INITIAL", "INI", "M"
    CopyOrMoveFiles "A:\", "A:\TEXT", "TXT", "M"
    CopyOrMoveFiles "A:\", "A:\WRITE", "WRI", "M"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been moved from root to top-level directories."
    Refresh
    
    ' Create the EXE_INI directory below the SYSTEM directory
    ' using the CreateFolder method ...
    mobjFSO.CreateFolder "A:\SYSTEM\EXE_INI"
    Print "Second-level directory for EXE and INI files has been made."
    
    ' Use the "CopyOrMoveFiles" Sub to copy the EXEs and INIs to the
    ' newly-created directory ...
    CopyOrMoveFiles "A:\EXECUTE", "A:\SYSTEM\EXE_INI", "EXE", "C"
    CopyOrMoveFiles "A:\INITIAL", "A:\SYSTEM\EXE_INI", "INI", "C"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been copied to EXE_INI directory."
    Refresh

    ' Create the TXT_WRI directory below the INITIAL directory
    ' using the CreateFolder method ...
    mobjFSO.CreateFolder "A:\INITIAL\TXT_WRI"
    Print "Second-level directory for TXT and WRI files has been made."
    ' Use the "CopyOrMoveFiles" Sub to copy the TXTs and WRIs to the
    ' newly-created directory ...
    CopyOrMoveFiles "A:\TEXT", "A:\INITIAL\TXT_WRI", "TXT", "C"
    CopyOrMoveFiles "A:\WRITE", "A:\INITIAL\TXT_WRI", "WRI", "C"
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print "Files have been copied to TXT_WRI directory."
    Refresh
    
    Print "Done."

    Exit Sub

cmdTryIt_Click_Error:
    
    MsgBox "The following error has occurred:" & vbNewLine _
         & "Error # " & Err.Number & " - " & Err.Description, _
           vbCritical, _
           "File System Commands Demo - Error"

End Sub

'------------------------------------------------------------------------------------------
Private Sub cmdReset_Click()
'------------------------------------------------------------------------------------------

    On Error GoTo cmdReset_Click_Error
    
    Cls
    
    ' To faciliate the moving of the files from their individual directories back to
    ' the root and subsequently deleting the individual directory, a Sub named
    ' MoveFilesBackToRoot was written. The Sub takes two arguments: (1) the individual
    ' directory name, and (2) the file extension of the files to be moved.
    
    ' It should be noted that in the MoveFilesBackToRoot Sub, the FSO's DeleteFolder
    ' method is used to delete the individual directories. An important difference
    ' between the DeleteFolder method and the native VB RmDir statement is that
    ' with the DeleteFolder method, the folder to be deleted need NOT be cleared of
    ' files or subdirectories below it; whereas with RmDir, the directory to be
    ' deleted DOES have to be cleared first. For this reason, the "EXE_INI" directory
    ' made below the "SYSTEM" directory and the "TXT_WRI" directory below the "INITIAL"
    ' directory need not be cleared prior to deleting the top-level "SYSTEM" and
    ' "INITIAL" directories.
    
    MoveFilesBackToRoot "SYSTEM", "SYS"
    MoveFilesBackToRoot "COMMAND", "COM"
    MoveFilesBackToRoot "EXECUTE", "EXE"
    MoveFilesBackToRoot "INITIAL", "INI"
    MoveFilesBackToRoot "TEXT", "TXT"
    MoveFilesBackToRoot "WRITE", "WRI"
    
    Print "Done."
    Refresh
    
    Exit Sub

cmdReset_Click_Error:
    
    MsgBox "The following error has occurred:" & vbNewLine _
         & "Error # " & Err.Number & " - " & Err.Description, _
           vbCritical, _
           "File System Commands Demo - Error"
    
End Sub

'------------------------------------------------------------------------------------------
Private Sub cmdExit_Click()
'------------------------------------------------------------------------------------------

    ' When using objects, it is good practice to release them from the system when
    ' you are done using them by Setting them to the keyword "Nothing":
    Set mobjFSO = Nothing
    
    End
    
End Sub

'------------------------------------------------------------------------------------------
Private Sub CopyOrMoveFiles(pstrSourcePath As String, _
                            pstrTargetPath As String, _
                            pstrExtension As String, _
                            pstrCopyOrMoveCode As String)
                            
' This Sub takes four arguments: (1) source path, (2) target path, (3) file extension,
' and (4) a one-character code indicating whether the files should be moved ("M") or
' copied ("C").
'------------------------------------------------------------------------------------------


    Dim strCurrentFile  As String
    Dim strPattern      As String
    Dim strSourceFile   As String
    Dim strTargetFile   As String
    
    ' If the source path does not already have a backslash at
    ' the end of it, add one ...
    If Right$(pstrSourcePath, 1) <> "\" Then
        pstrSourcePath = pstrSourcePath & "\"
    End If

    ' If the target path does not already have a backslash at
    ' the end of it, add one ...
    If Right$(pstrTargetPath, 1) <> "\" Then
        pstrTargetPath = pstrTargetPath & "\"
    End If
    
    ' Create the "source pattern" by concatenating the source path, "*.", and
    ' the extension. For example, if "A:\" was passed in as the source path and
    ' "SYS" was passed in as the extension, the value of strPattern would be
    ' "A:\*.SYS".
    strPattern = pstrSourcePath & "*." & pstrExtension

    ' The coding for this part of the process is easier with the FSO. In the previous
    ' topic which used the native VB file processing statements, we had to use the
    ' "Dir" function in a loop and copy the files one at a time; the native "FileCopy"
    ' command cannot copy multiple files at once (i.e., a wildcard pattern cannot be
    ' used). If a "move" was specified, the files that were copied had to be deleted
    ' with the Kill statement (the Kill statement does support multiple files using a
    ' wildcard pattern). There is no specific statement to move files in the set of
    ' native VB file processing statements.
    
    ' On the other hand, the FSO has both a CopyFile and a MoveFile method, both of
    ' which support file specifications with a wildcard pattern, enabling you to
    ' copy or move multiple files at once.

    If pstrCopyOrMoveCode = "M" Then
        mobjFSO.MoveFile strPattern, pstrTargetPath
    Else
        mobjFSO.CopyFile strPattern, pstrTargetPath
    End If
    
End Sub

'------------------------------------------------------------------------------------------
Private Sub MoveFilesBackToRoot(pstrDirName As String, _
                                pstrExtension As String)
'
' This Sub takes two arguments: (1) the individual directory name, and (2) the file
' extension of the files to be moved.
'------------------------------------------------------------------------------------------

    ' Use the CopyOrMoveFiles Sub to move the files with the specified extension
    ' from their "home" directory back to the root ...
    CopyOrMoveFiles ("A:\" & pstrDirName), "A:\", pstrExtension, "M"
    
    ' Delete the individual directory using the DeleteFolder method ...
    ' Note: The DeleteFolder method does NOT require that the files or subdirectories
    ' below it be cleared first prior to deleting it. For this reason, the "EXE_INI"
    ' directory made below the "SYSTEM" directory and the "TXT_WRI" directory below
    ' the "INITIAL" directory will not be cleared prior to deleting the top-level
    ' "SYSTEM" and  "INITIAL" directories.
    mobjFSO.DeleteFolder "A:\" & pstrDirName
    
    ' Free up the OS for a sec and ensure message is displayed ...
    DoEvents
    Print pstrDirName & " directory has been cleared; files moved back to root."
    Refresh

End Sub
